// java wrapper for vtkODBCDatabase object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkSystemIncludes.h"
#include "vtkODBCDatabase.h"
#include "vtkJavaUtil.h"

#include "vtkStdString.h"

#include <sstream>
extern "C" JNIEXPORT void* vtkSQLDatabase_Typecast(void *op,char *dType);

extern "C" JNIEXPORT void* vtkODBCDatabase_Typecast(void *me,char *dType)
{
  void* res;
  if (!strcmp("vtkODBCDatabase",dType)) { return me; }
  if ((res= vtkSQLDatabase_Typecast(me,dType)) != nullptr) { return res; }
  return nullptr;
}


extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkODBCDatabase_IsTypeOf_10(JNIEnv *env, jobject obj,jstring id0)
{
  vtkODBCDatabase *op;
  char    *temp0;
  int      temp20;
  temp0 = vtkJavaUTFToChar(env,id0);

  op = (vtkODBCDatabase *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->IsTypeOf(temp0);
  delete[] temp0;
  return temp20;
}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkODBCDatabase_IsA_11(JNIEnv *env, jobject obj,jstring id0)
{
  vtkODBCDatabase *op;
  char    *temp0;
  int      temp20;
  temp0 = vtkJavaUTFToChar(env,id0);

  op = (vtkODBCDatabase *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->IsA(temp0);
  delete[] temp0;
  return temp20;
}

extern "C" JNIEXPORT jboolean  JNICALL Java_vtk_vtkODBCDatabase_Open_12(JNIEnv *env, jobject obj,jstring id0)
{
  vtkODBCDatabase *op;
  char    *temp0;
  bool   temp20;
  temp0 = vtkJavaUTFToChar(env,id0);

  op = (vtkODBCDatabase *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->Open(temp0);
  delete[] temp0;
  return temp20;
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkODBCDatabase_Close_13(JNIEnv *env, jobject obj)
{
  vtkODBCDatabase *op;

  op = (vtkODBCDatabase *)vtkJavaGetPointerFromObject(env,obj);
  op->Close();
}

extern "C" JNIEXPORT jboolean  JNICALL Java_vtk_vtkODBCDatabase_IsOpen_14(JNIEnv *env, jobject obj)
{
  vtkODBCDatabase *op;
  bool   temp20;

  op = (vtkODBCDatabase *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->IsOpen();
  return temp20;
}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkODBCDatabase_GetQueryInstance_15(JNIEnv *env, jobject obj)
{
  vtkODBCDatabase *op;
  vtkSQLQuery  *temp20;

  op = (vtkODBCDatabase *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->GetQueryInstance();
  return (jlong)(size_t)temp20;}

extern "C" JNIEXPORT jstring  JNICALL Java_vtk_vtkODBCDatabase_GetLastErrorText_16(JNIEnv *env, jobject obj)
{
  vtkODBCDatabase *op;
  const char    *temp20;

  op = (vtkODBCDatabase *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->GetLastErrorText();
  return vtkJavaMakeJavaString(env,temp20);
}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkODBCDatabase_GetTables_17(JNIEnv *env, jobject obj)
{
  vtkODBCDatabase *op;
  vtkStringArray  *temp20;

  op = (vtkODBCDatabase *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->GetTables();
  return (jlong)(size_t)temp20;}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkODBCDatabase_GetRecord_18(JNIEnv *env, jobject obj,jstring id0)
{
  vtkODBCDatabase *op;
  char    *temp0;
  vtkStringArray  *temp20;
  temp0 = vtkJavaUTFToChar(env,id0);

  op = (vtkODBCDatabase *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->GetRecord(temp0);
  delete[] temp0;
  return (jlong)(size_t)temp20;}

extern "C" JNIEXPORT jboolean  JNICALL Java_vtk_vtkODBCDatabase_IsSupported_19(JNIEnv *env, jobject obj,jint id0)
{
  vtkODBCDatabase *op;
  int      temp0;
  bool   temp20;
  temp0 = id0;

  op = (vtkODBCDatabase *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->IsSupported(temp0);
  return temp20;
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkODBCDatabase_SetDataSourceName_110(JNIEnv *env, jobject obj,jstring id0)
{
  vtkODBCDatabase *op;
  char    *temp0;
  temp0 = vtkJavaUTFToChar(env,id0);

  op = (vtkODBCDatabase *)vtkJavaGetPointerFromObject(env,obj);
  op->SetDataSourceName(temp0);
  delete[] temp0;
}

extern "C" JNIEXPORT jstring  JNICALL Java_vtk_vtkODBCDatabase_GetDataSourceName_111(JNIEnv *env, jobject obj)
{
  vtkODBCDatabase *op;
  char    *temp20;

  op = (vtkODBCDatabase *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->GetDataSourceName();
  return vtkJavaMakeJavaString(env,temp20);
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkODBCDatabase_SetServerPort_112(JNIEnv *env, jobject obj,jint id0)
{
  vtkODBCDatabase *op;
  int      temp0;
  temp0 = id0;

  op = (vtkODBCDatabase *)vtkJavaGetPointerFromObject(env,obj);
  op->SetServerPort(temp0);
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkODBCDatabase_SetHostName_113(JNIEnv *env, jobject obj,jstring id0)
{
  vtkODBCDatabase *op;
  char    *temp0;
  temp0 = vtkJavaUTFToChar(env,id0);

  op = (vtkODBCDatabase *)vtkJavaGetPointerFromObject(env,obj);
  op->SetHostName(temp0);
  delete[] temp0;
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkODBCDatabase_SetUserName_114(JNIEnv *env, jobject obj,jstring id0)
{
  vtkODBCDatabase *op;
  char    *temp0;
  temp0 = vtkJavaUTFToChar(env,id0);

  op = (vtkODBCDatabase *)vtkJavaGetPointerFromObject(env,obj);
  op->SetUserName(temp0);
  delete[] temp0;
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkODBCDatabase_SetDatabaseName_115(JNIEnv *env, jobject obj,jstring id0)
{
  vtkODBCDatabase *op;
  char    *temp0;
  temp0 = vtkJavaUTFToChar(env,id0);

  op = (vtkODBCDatabase *)vtkJavaGetPointerFromObject(env,obj);
  op->SetDatabaseName(temp0);
  delete[] temp0;
}

extern "C" JNIEXPORT jstring  JNICALL Java_vtk_vtkODBCDatabase_GetDatabaseName_116(JNIEnv *env, jobject obj)
{
  vtkODBCDatabase *op;
  char    *temp20;

  op = (vtkODBCDatabase *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->GetDatabaseName();
  return vtkJavaMakeJavaString(env,temp20);
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkODBCDatabase_SetPassword_117(JNIEnv *env, jobject obj,jstring id0)
{
  vtkODBCDatabase *op;
  char    *temp0;
  temp0 = vtkJavaUTFToChar(env,id0);

  op = (vtkODBCDatabase *)vtkJavaGetPointerFromObject(env,obj);
  op->SetPassword(temp0);
  delete[] temp0;
}

extern "C" JNIEXPORT jboolean  JNICALL Java_vtk_vtkODBCDatabase_HasError_118(JNIEnv *env, jobject obj)
{
  vtkODBCDatabase *op;
  bool   temp20;

  op = (vtkODBCDatabase *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->HasError();
  return temp20;
}

extern "C" JNIEXPORT jstring  JNICALL Java_vtk_vtkODBCDatabase_GetDatabaseType_119(JNIEnv *env, jobject obj)
{
  vtkODBCDatabase *op;
  const char    *temp20;

  op = (vtkODBCDatabase *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->GetDatabaseType();
  return vtkJavaMakeJavaString(env,temp20);
}

extern "C" JNIEXPORT jstring  JNICALL Java_vtk_vtkODBCDatabase_GetURL_120(JNIEnv *env, jobject obj)
{
  vtkODBCDatabase *op;
  vtkStdString   temp20;

  op = (vtkODBCDatabase *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->GetURL();
  return vtkJavaMakeJavaString(env,temp20.c_str());
}

extern "C" JNIEXPORT jstring  JNICALL Java_vtk_vtkODBCDatabase_GetColumnSpecification_121(JNIEnv *env, jobject obj,jobject id0,jint id1,jint id2)
{
  vtkODBCDatabase *op;
  vtkSQLDatabaseSchema  *temp0;
  int      temp1;
  int      temp2;
  vtkStdString   temp20;
  temp0 = (vtkSQLDatabaseSchema *)(vtkJavaGetPointerFromObject(env,id0));
  temp1 = id1;
  temp2 = id2;

  op = (vtkODBCDatabase *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->GetColumnSpecification(temp0,temp1,temp2);
  return vtkJavaMakeJavaString(env,temp20.c_str());
}

extern "C" JNIEXPORT jboolean  JNICALL Java_vtk_vtkODBCDatabase_CreateDatabase_122(JNIEnv *env, jobject obj,jstring id0,jboolean id1)
{
  vtkODBCDatabase *op;
  char    *temp0;
  bool   temp1;
  bool   temp20;
  temp0 = vtkJavaUTFToChar(env,id0);
  temp1 = (id1 != 0) ? true : false;

  op = (vtkODBCDatabase *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->CreateDatabase(temp0,temp1);
  delete[] temp0;
  return temp20;
}

extern "C" JNIEXPORT jboolean  JNICALL Java_vtk_vtkODBCDatabase_DropDatabase_123(JNIEnv *env, jobject obj,jstring id0)
{
  vtkODBCDatabase *op;
  char    *temp0;
  bool   temp20;
  temp0 = vtkJavaUTFToChar(env,id0);

  op = (vtkODBCDatabase *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->DropDatabase(temp0);
  delete[] temp0;
  return temp20;
}

extern "C" JNIEXPORT jboolean  JNICALL Java_vtk_vtkODBCDatabase_ParseURL_124(JNIEnv *env, jobject obj,jstring id0)
{
  vtkODBCDatabase *op;
  char    *temp0;
  bool   temp20;
  temp0 = vtkJavaUTFToChar(env,id0);

  op = (vtkODBCDatabase *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->ParseURL(temp0);
  delete[] temp0;
  return temp20;
}

extern "C" JNIEXPORT jlong JNICALL Java_vtk_vtkODBCDatabase_VTKInit(JNIEnv *, jobject)
{
  vtkODBCDatabase *aNewOne = vtkODBCDatabase::New();
  return (jlong)(size_t)(void*)aNewOne;
}
