// python wrapper for vtkGDALRasterReader
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkStdString.h"
#include "vtkGDALRasterReader.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkGDALRasterReader(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkGDALRasterReader_ClassNew(); }

#ifndef DECLARED_PyvtkImageReader2_ClassNew
extern "C" { PyObject *PyvtkImageReader2_ClassNew(); }
#define DECLARED_PyvtkImageReader2_ClassNew
#endif

static const char *PyvtkGDALRasterReader_Doc =
  "vtkGDALRasterReader - Read raster file formats using GDAL.\n\n"
  "Superclass: vtkImageReader2\n\n"
  "vtkGDALRasterReader is a source object that reads raster files and\n"
  "uses GDAL as the underlying library for the task. GDAL is required\n"
  "for this reader. The output of the reader is a vtkUniformGrid\n"
  "(vtkImageData with blanking) with cell data.\n\n"
  "@sa\n"
  "vtkUniformGrid, vtkImageData\n\n";


static PyObject *
PyvtkGDALRasterReader_IsTypeOf(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "IsTypeOf");

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkGDALRasterReader::IsTypeOf(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkGDALRasterReader_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGDALRasterReader *op = static_cast<vtkGDALRasterReader *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkGDALRasterReader::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkGDALRasterReader_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObjectBase *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObjectBase"))
  {
    vtkGDALRasterReader *tempr = vtkGDALRasterReader::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkGDALRasterReader_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGDALRasterReader *op = static_cast<vtkGDALRasterReader *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    vtkGDALRasterReader *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkGDALRasterReader::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkGDALRasterReader_CanReadFile(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "CanReadFile");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGDALRasterReader *op = static_cast<vtkGDALRasterReader *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->CanReadFile(temp0) :
      op->vtkGDALRasterReader::CanReadFile(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkGDALRasterReader_GetProjectionString(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetProjectionString");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGDALRasterReader *op = static_cast<vtkGDALRasterReader *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetProjectionString() :
      op->vtkGDALRasterReader::GetProjectionString());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkGDALRasterReader_GetGeoCornerPoints(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetGeoCornerPoints");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGDALRasterReader *op = static_cast<vtkGDALRasterReader *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    const double *tempr = (ap.IsBound() ?
      op->GetGeoCornerPoints() :
      op->vtkGDALRasterReader::GetGeoCornerPoints());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkGDALRasterReader_SetTargetDimensions_s1(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetTargetDimensions");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGDALRasterReader *op = static_cast<vtkGDALRasterReader *>(vp);

  int temp0;
  int temp1;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1))
  {
    if (ap.IsBound())
    {
      op->SetTargetDimensions(temp0, temp1);
    }
    else
    {
      op->vtkGDALRasterReader::SetTargetDimensions(temp0, temp1);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyObject *
PyvtkGDALRasterReader_SetTargetDimensions_s2(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetTargetDimensions");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGDALRasterReader *op = static_cast<vtkGDALRasterReader *>(vp);

  const size_t size0 = 2;
  int temp0[2];
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetArray(temp0, size0))
  {
    if (ap.IsBound())
    {
      op->SetTargetDimensions(temp0);
    }
    else
    {
      op->vtkGDALRasterReader::SetTargetDimensions(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyObject *
PyvtkGDALRasterReader_SetTargetDimensions(PyObject *self, PyObject *args)
{
  int nargs = vtkPythonArgs::GetArgCount(self, args);

  switch(nargs)
  {
    case 2:
      return PyvtkGDALRasterReader_SetTargetDimensions_s1(self, args);
    case 1:
      return PyvtkGDALRasterReader_SetTargetDimensions_s2(self, args);
  }

  vtkPythonArgs::ArgCountError(nargs, "SetTargetDimensions");
  return nullptr;
}



static PyObject *
PyvtkGDALRasterReader_GetTargetDimensions(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetTargetDimensions");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGDALRasterReader *op = static_cast<vtkGDALRasterReader *>(vp);

  size_t sizer = 2;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    int *tempr = (ap.IsBound() ?
      op->GetTargetDimensions() :
      op->vtkGDALRasterReader::GetTargetDimensions());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildTuple(tempr, sizer);
    }
  }

  return result;
}


static PyObject *
PyvtkGDALRasterReader_GetRasterDimensions(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetRasterDimensions");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGDALRasterReader *op = static_cast<vtkGDALRasterReader *>(vp);

  size_t sizer = 2;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    int *tempr = (ap.IsBound() ?
      op->GetRasterDimensions() :
      op->vtkGDALRasterReader::GetRasterDimensions());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildTuple(tempr, sizer);
    }
  }

  return result;
}


static PyObject *
PyvtkGDALRasterReader_GetMetaData(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetMetaData");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGDALRasterReader *op = static_cast<vtkGDALRasterReader *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    const std::vector<std::string> *tempr = (ap.IsBound() ?
      &op->GetMetaData() :
      &op->vtkGDALRasterReader::GetMetaData());

    if (!ap.ErrorOccurred())
    {
      if (tempr->size() == 0)
      {
        result = PyTuple_New(0);
      }
      else
      {
        result = ap.BuildTuple(tempr->data(), tempr->size());
      }
    }
  }

  return result;
}


static PyObject *
PyvtkGDALRasterReader_GetInvalidValue(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetInvalidValue");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGDALRasterReader *op = static_cast<vtkGDALRasterReader *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    double tempr = (ap.IsBound() ?
      op->GetInvalidValue() :
      op->vtkGDALRasterReader::GetInvalidValue());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkGDALRasterReader_GetDomainMetaData(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetDomainMetaData");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGDALRasterReader *op = static_cast<vtkGDALRasterReader *>(vp);

  std::string temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    std::vector<std::string> tempr = (ap.IsBound() ?
      op->GetDomainMetaData(temp0) :
      op->vtkGDALRasterReader::GetDomainMetaData(temp0));

    if (!ap.ErrorOccurred())
    {
      if (tempr.size() == 0)
      {
        result = PyTuple_New(0);
      }
      else
      {
        result = ap.BuildTuple(tempr.data(), tempr.size());
      }
    }
  }

  return result;
}


static PyObject *
PyvtkGDALRasterReader_GetDriverShortName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetDriverShortName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGDALRasterReader *op = static_cast<vtkGDALRasterReader *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    const std::string *tempr = (ap.IsBound() ?
      &op->GetDriverShortName() :
      &op->vtkGDALRasterReader::GetDriverShortName());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(*tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkGDALRasterReader_GetDriverLongName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetDriverLongName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGDALRasterReader *op = static_cast<vtkGDALRasterReader *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    const std::string *tempr = (ap.IsBound() ?
      &op->GetDriverLongName() :
      &op->vtkGDALRasterReader::GetDriverLongName());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(*tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkGDALRasterReader_GetNumberOfCells(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNumberOfCells");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGDALRasterReader *op = static_cast<vtkGDALRasterReader *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    vtkIdType tempr = (ap.IsBound() ?
      op->GetNumberOfCells() :
      op->vtkGDALRasterReader::GetNumberOfCells());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyMethodDef PyvtkGDALRasterReader_Methods[] = {
  {"IsTypeOf", PyvtkGDALRasterReader_IsTypeOf, METH_VARARGS,
   "V.IsTypeOf(string) -> int\nC++: static vtkTypeBool IsTypeOf(const char *type)\n\nReturn 1 if this class type is the same type of (or a subclass\nof) the named class. Returns 0 otherwise. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"IsA", PyvtkGDALRasterReader_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: vtkTypeBool IsA(const char *type) override;\n\nReturn 1 if this class is the same type of (or a subclass of) the\nnamed class. Returns 0 otherwise. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"SafeDownCast", PyvtkGDALRasterReader_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObjectBase) -> vtkGDALRasterReader\nC++: static vtkGDALRasterReader *SafeDownCast(vtkObjectBase *o)\n\n"},
  {"NewInstance", PyvtkGDALRasterReader_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkGDALRasterReader\nC++: vtkGDALRasterReader *NewInstance()\n\n"},
  {"CanReadFile", PyvtkGDALRasterReader_CanReadFile, METH_VARARGS,
   "V.CanReadFile(string) -> int\nC++: int CanReadFile(const char *fname) override;\n\nIs this file supported\n"},
  {"GetProjectionString", PyvtkGDALRasterReader_GetProjectionString, METH_VARARGS,
   "V.GetProjectionString() -> string\nC++: const char *GetProjectionString()\n\nReturn proj4 spatial reference\n"},
  {"GetGeoCornerPoints", PyvtkGDALRasterReader_GetGeoCornerPoints, METH_VARARGS,
   "V.GetGeoCornerPoints() -> (float, ...)\nC++: const double *GetGeoCornerPoints()\n\nReturn geo-referenced corner points (Upper left, lower left,\nlower right, upper right)\n"},
  {"SetTargetDimensions", PyvtkGDALRasterReader_SetTargetDimensions, METH_VARARGS,
   "V.SetTargetDimensions(int, int)\nC++: void SetTargetDimensions(int, int)\nV.SetTargetDimensions((int, int))\nC++: void SetTargetDimensions(int a[2])\n\n"},
  {"GetTargetDimensions", PyvtkGDALRasterReader_GetTargetDimensions, METH_VARARGS,
   "V.GetTargetDimensions() -> (int, int)\nC++: int *GetTargetDimensions()\n\n"},
  {"GetRasterDimensions", PyvtkGDALRasterReader_GetRasterDimensions, METH_VARARGS,
   "V.GetRasterDimensions() -> (int, int)\nC++: int *GetRasterDimensions()\n\n"},
  {"GetMetaData", PyvtkGDALRasterReader_GetMetaData, METH_VARARGS,
   "V.GetMetaData() -> Stvector_ISt6stringE\nC++: const std::vector<std::string> &GetMetaData()\n\nReturn metadata as reported by GDAL\n"},
  {"GetInvalidValue", PyvtkGDALRasterReader_GetInvalidValue, METH_VARARGS,
   "V.GetInvalidValue() -> float\nC++: double GetInvalidValue()\n\nReturn the invalid value for a pixel (for blanking purposes)\n"},
  {"GetDomainMetaData", PyvtkGDALRasterReader_GetDomainMetaData, METH_VARARGS,
   "V.GetDomainMetaData(string) -> Stvector_ISt6stringE\nC++: std::vector<std::string> GetDomainMetaData(\n    const std::string &domain)\n\nReturn domain metadata\n"},
  {"GetDriverShortName", PyvtkGDALRasterReader_GetDriverShortName, METH_VARARGS,
   "V.GetDriverShortName() -> string\nC++: const std::string &GetDriverShortName()\n\nReturn driver name which was used to read the current data\n"},
  {"GetDriverLongName", PyvtkGDALRasterReader_GetDriverLongName, METH_VARARGS,
   "V.GetDriverLongName() -> string\nC++: const std::string &GetDriverLongName()\n\nReturn driver name which was used to read the current data\n"},
  {"GetNumberOfCells", PyvtkGDALRasterReader_GetNumberOfCells, METH_VARARGS,
   "V.GetNumberOfCells() -> int\nC++: vtkIdType GetNumberOfCells()\n\nReturn the number of cells that are not set to GDAL NODATA\n"},
  {nullptr, nullptr, 0, nullptr}
};

static PyTypeObject PyvtkGDALRasterReader_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkIOGDALPython.vtkGDALRasterReader", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_vectorcall_offset
  nullptr, // tp_getattr
  nullptr, // tp_setattr
  nullptr, // tp_compare
  PyVTKObject_Repr, // tp_repr
  nullptr, // tp_as_number
  nullptr, // tp_as_sequence
  nullptr, // tp_as_mapping
  nullptr, // tp_hash
  nullptr, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  PyvtkGDALRasterReader_Doc, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  nullptr, // tp_clear
  nullptr, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  nullptr, // tp_iter
  nullptr, // tp_iternext
  nullptr, // tp_methods
  nullptr, // tp_members
  PyVTKObject_GetSet, // tp_getset
  nullptr, // tp_base
  nullptr, // tp_dict
  nullptr, // tp_descr_get
  nullptr, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  nullptr, // tp_init
  nullptr, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  nullptr, // tp_is_gc
  nullptr, // tp_bases
  nullptr, // tp_mro
  nullptr, // tp_cache
  nullptr, // tp_subclasses
  nullptr, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkGDALRasterReader_StaticNew()
{
  return vtkGDALRasterReader::New();
}

PyObject *PyvtkGDALRasterReader_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkGDALRasterReader_Type, PyvtkGDALRasterReader_Methods,
    "vtkGDALRasterReader",
 &PyvtkGDALRasterReader_StaticNew);

  PyTypeObject *pytype = &PyvtkGDALRasterReader_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkImageReader2_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

void PyVTKAddFile_vtkGDALRasterReader(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkGDALRasterReader_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkGDALRasterReader", o) != 0)
  {
    Py_DECREF(o);
  }

}

