// python wrapper for vtkGeoJSONFeature
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkGeoJSONFeature.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkGeoJSONFeature(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkGeoJSONFeature_ClassNew(); }

#ifndef DECLARED_PyvtkDataObject_ClassNew
extern "C" { PyObject *PyvtkDataObject_ClassNew(); }
#define DECLARED_PyvtkDataObject_ClassNew
#endif

static const char *PyvtkGeoJSONFeature_Doc =
  "vtkGeoJSONFeature - Represents GeoJSON feature geometry & properties\n\n"
  "Superclass: vtkDataObject\n\n"
  "This class is used by the vtkGeoJSONReader when parsing GeoJSON\n"
  "input. It is not intended to be instantiated by applications\n"
  "directly.\n\n";


static PyObject *
PyvtkGeoJSONFeature_IsTypeOf(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "IsTypeOf");

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkGeoJSONFeature::IsTypeOf(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkGeoJSONFeature_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoJSONFeature *op = static_cast<vtkGeoJSONFeature *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkGeoJSONFeature::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkGeoJSONFeature_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObjectBase *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObjectBase"))
  {
    vtkGeoJSONFeature *tempr = vtkGeoJSONFeature::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkGeoJSONFeature_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoJSONFeature *op = static_cast<vtkGeoJSONFeature *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    vtkGeoJSONFeature *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkGeoJSONFeature::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkGeoJSONFeature_SetOutlinePolygons(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetOutlinePolygons");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoJSONFeature *op = static_cast<vtkGeoJSONFeature *>(vp);

  bool temp0 = false;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetOutlinePolygons(temp0);
    }
    else
    {
      op->vtkGeoJSONFeature::SetOutlinePolygons(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkGeoJSONFeature_GetOutlinePolygons(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetOutlinePolygons");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoJSONFeature *op = static_cast<vtkGeoJSONFeature *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    bool tempr = (ap.IsBound() ?
      op->GetOutlinePolygons() :
      op->vtkGeoJSONFeature::GetOutlinePolygons());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkGeoJSONFeature_OutlinePolygonsOn(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "OutlinePolygonsOn");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoJSONFeature *op = static_cast<vtkGeoJSONFeature *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->OutlinePolygonsOn();
    }
    else
    {
      op->vtkGeoJSONFeature::OutlinePolygonsOn();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkGeoJSONFeature_OutlinePolygonsOff(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "OutlinePolygonsOff");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoJSONFeature *op = static_cast<vtkGeoJSONFeature *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->OutlinePolygonsOff();
    }
    else
    {
      op->vtkGeoJSONFeature::OutlinePolygonsOff();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyMethodDef PyvtkGeoJSONFeature_Methods[] = {
  {"IsTypeOf", PyvtkGeoJSONFeature_IsTypeOf, METH_VARARGS,
   "V.IsTypeOf(string) -> int\nC++: static vtkTypeBool IsTypeOf(const char *type)\n\nReturn 1 if this class type is the same type of (or a subclass\nof) the named class. Returns 0 otherwise. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"IsA", PyvtkGeoJSONFeature_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: vtkTypeBool IsA(const char *type) override;\n\nReturn 1 if this class is the same type of (or a subclass of) the\nnamed class. Returns 0 otherwise. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"SafeDownCast", PyvtkGeoJSONFeature_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObjectBase) -> vtkGeoJSONFeature\nC++: static vtkGeoJSONFeature *SafeDownCast(vtkObjectBase *o)\n\n"},
  {"NewInstance", PyvtkGeoJSONFeature_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkGeoJSONFeature\nC++: vtkGeoJSONFeature *NewInstance()\n\n"},
  {"SetOutlinePolygons", PyvtkGeoJSONFeature_SetOutlinePolygons, METH_VARARGS,
   "V.SetOutlinePolygons(bool)\nC++: virtual void SetOutlinePolygons(bool _arg)\n\nSet/get option to generate the border outlining each polygon, so\nthat resulting cells are vtkPolyLine instead of vtkPolygon. The\ndefault is off\n"},
  {"GetOutlinePolygons", PyvtkGeoJSONFeature_GetOutlinePolygons, METH_VARARGS,
   "V.GetOutlinePolygons() -> bool\nC++: virtual bool GetOutlinePolygons()\n\nSet/get option to generate the border outlining each polygon, so\nthat resulting cells are vtkPolyLine instead of vtkPolygon. The\ndefault is off\n"},
  {"OutlinePolygonsOn", PyvtkGeoJSONFeature_OutlinePolygonsOn, METH_VARARGS,
   "V.OutlinePolygonsOn()\nC++: virtual void OutlinePolygonsOn()\n\nSet/get option to generate the border outlining each polygon, so\nthat resulting cells are vtkPolyLine instead of vtkPolygon. The\ndefault is off\n"},
  {"OutlinePolygonsOff", PyvtkGeoJSONFeature_OutlinePolygonsOff, METH_VARARGS,
   "V.OutlinePolygonsOff()\nC++: virtual void OutlinePolygonsOff()\n\nSet/get option to generate the border outlining each polygon, so\nthat resulting cells are vtkPolyLine instead of vtkPolygon. The\ndefault is off\n"},
  {nullptr, nullptr, 0, nullptr}
};

static PyTypeObject PyvtkGeoJSONFeature_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkIOGeoJSONPython.vtkGeoJSONFeature", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_vectorcall_offset
  nullptr, // tp_getattr
  nullptr, // tp_setattr
  nullptr, // tp_compare
  PyVTKObject_Repr, // tp_repr
  nullptr, // tp_as_number
  nullptr, // tp_as_sequence
  nullptr, // tp_as_mapping
  nullptr, // tp_hash
  nullptr, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  PyvtkGeoJSONFeature_Doc, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  nullptr, // tp_clear
  nullptr, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  nullptr, // tp_iter
  nullptr, // tp_iternext
  nullptr, // tp_methods
  nullptr, // tp_members
  PyVTKObject_GetSet, // tp_getset
  nullptr, // tp_base
  nullptr, // tp_dict
  nullptr, // tp_descr_get
  nullptr, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  nullptr, // tp_init
  nullptr, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  nullptr, // tp_is_gc
  nullptr, // tp_bases
  nullptr, // tp_mro
  nullptr, // tp_cache
  nullptr, // tp_subclasses
  nullptr, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkGeoJSONFeature_StaticNew()
{
  return vtkGeoJSONFeature::New();
}

PyObject *PyvtkGeoJSONFeature_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkGeoJSONFeature_Type, PyvtkGeoJSONFeature_Methods,
    "vtkGeoJSONFeature",
 &PyvtkGeoJSONFeature_StaticNew);

  PyTypeObject *pytype = &PyvtkGeoJSONFeature_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkDataObject_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

void PyVTKAddFile_vtkGeoJSONFeature(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkGeoJSONFeature_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkGeoJSONFeature", o) != 0)
  {
    Py_DECREF(o);
  }

}

