// python wrapper for vtkReebGraphSimplificationFilter
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkReebGraphSimplificationFilter.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkReebGraphSimplificationFilter(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkReebGraphSimplificationFilter_ClassNew(); }

#ifndef DECLARED_PyvtkDirectedGraphAlgorithm_ClassNew
extern "C" { PyObject *PyvtkDirectedGraphAlgorithm_ClassNew(); }
#define DECLARED_PyvtkDirectedGraphAlgorithm_ClassNew
#endif

static const char *PyvtkReebGraphSimplificationFilter_Doc =
  "vtkReebGraphSimplificationFilter - simplify an input Reeb graph.\n\n"
  "Superclass: vtkDirectedGraphAlgorithm\n\n"
  "The filter takes an input vtkReebGraph object and outputs a\n"
  "vtkReebGraph object.\n\n";


static PyObject *
PyvtkReebGraphSimplificationFilter_IsTypeOf(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "IsTypeOf");

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkReebGraphSimplificationFilter::IsTypeOf(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkReebGraphSimplificationFilter_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkReebGraphSimplificationFilter *op = static_cast<vtkReebGraphSimplificationFilter *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkReebGraphSimplificationFilter::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkReebGraphSimplificationFilter_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObjectBase *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObjectBase"))
  {
    vtkReebGraphSimplificationFilter *tempr = vtkReebGraphSimplificationFilter::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkReebGraphSimplificationFilter_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkReebGraphSimplificationFilter *op = static_cast<vtkReebGraphSimplificationFilter *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    vtkReebGraphSimplificationFilter *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkReebGraphSimplificationFilter::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkReebGraphSimplificationFilter_SetSimplificationThreshold(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetSimplificationThreshold");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkReebGraphSimplificationFilter *op = static_cast<vtkReebGraphSimplificationFilter *>(vp);

  double temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetSimplificationThreshold(temp0);
    }
    else
    {
      op->vtkReebGraphSimplificationFilter::SetSimplificationThreshold(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkReebGraphSimplificationFilter_GetSimplificationThreshold(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetSimplificationThreshold");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkReebGraphSimplificationFilter *op = static_cast<vtkReebGraphSimplificationFilter *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    double tempr = (ap.IsBound() ?
      op->GetSimplificationThreshold() :
      op->vtkReebGraphSimplificationFilter::GetSimplificationThreshold());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkReebGraphSimplificationFilter_SetSimplificationMetric(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetSimplificationMetric");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkReebGraphSimplificationFilter *op = static_cast<vtkReebGraphSimplificationFilter *>(vp);

  vtkReebGraphSimplificationMetric *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkReebGraphSimplificationMetric"))
  {
    if (ap.IsBound())
    {
      op->SetSimplificationMetric(temp0);
    }
    else
    {
      op->vtkReebGraphSimplificationFilter::SetSimplificationMetric(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkReebGraphSimplificationFilter_GetOutput(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetOutput");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkReebGraphSimplificationFilter *op = static_cast<vtkReebGraphSimplificationFilter *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    vtkReebGraph *tempr = (ap.IsBound() ?
      op->GetOutput() :
      op->vtkReebGraphSimplificationFilter::GetOutput());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}

static PyMethodDef PyvtkReebGraphSimplificationFilter_Methods[] = {
  {"IsTypeOf", PyvtkReebGraphSimplificationFilter_IsTypeOf, METH_VARARGS,
   "V.IsTypeOf(string) -> int\nC++: static vtkTypeBool IsTypeOf(const char *type)\n\nReturn 1 if this class type is the same type of (or a subclass\nof) the named class. Returns 0 otherwise. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"IsA", PyvtkReebGraphSimplificationFilter_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: vtkTypeBool IsA(const char *type) override;\n\nReturn 1 if this class is the same type of (or a subclass of) the\nnamed class. Returns 0 otherwise. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"SafeDownCast", PyvtkReebGraphSimplificationFilter_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObjectBase) -> vtkReebGraphSimplificationFilter\nC++: static vtkReebGraphSimplificationFilter *SafeDownCast(\n    vtkObjectBase *o)\n\n"},
  {"NewInstance", PyvtkReebGraphSimplificationFilter_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkReebGraphSimplificationFilter\nC++: vtkReebGraphSimplificationFilter *NewInstance()\n\n"},
  {"SetSimplificationThreshold", PyvtkReebGraphSimplificationFilter_SetSimplificationThreshold, METH_VARARGS,
   "V.SetSimplificationThreshold(float)\nC++: virtual void SetSimplificationThreshold(double _arg)\n\nSet the persistence threshold for simplification (from 0 to 1).\nDefault value: 0 (no simplification).\n"},
  {"GetSimplificationThreshold", PyvtkReebGraphSimplificationFilter_GetSimplificationThreshold, METH_VARARGS,
   "V.GetSimplificationThreshold() -> float\nC++: virtual double GetSimplificationThreshold()\n\nSet the persistence threshold for simplification (from 0 to 1).\nDefault value: 0 (no simplification).\n"},
  {"SetSimplificationMetric", PyvtkReebGraphSimplificationFilter_SetSimplificationMetric, METH_VARARGS,
   "V.SetSimplificationMetric(vtkReebGraphSimplificationMetric)\nC++: void SetSimplificationMetric(\n    vtkReebGraphSimplificationMetric *metric)\n\nSet the persistence metric evaluation code Default value: nullptr\n(standard topological persistence).\n"},
  {"GetOutput", PyvtkReebGraphSimplificationFilter_GetOutput, METH_VARARGS,
   "V.GetOutput() -> vtkReebGraph\nC++: vtkReebGraph *GetOutput()\n\nGet the output data object for a port on this algorithm.\n"},
  {nullptr, nullptr, 0, nullptr}
};

static PyTypeObject PyvtkReebGraphSimplificationFilter_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkFiltersReebGraphPython.vtkReebGraphSimplificationFilter", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_vectorcall_offset
  nullptr, // tp_getattr
  nullptr, // tp_setattr
  nullptr, // tp_compare
  PyVTKObject_Repr, // tp_repr
  nullptr, // tp_as_number
  nullptr, // tp_as_sequence
  nullptr, // tp_as_mapping
  nullptr, // tp_hash
  nullptr, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  PyvtkReebGraphSimplificationFilter_Doc, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  nullptr, // tp_clear
  nullptr, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  nullptr, // tp_iter
  nullptr, // tp_iternext
  nullptr, // tp_methods
  nullptr, // tp_members
  PyVTKObject_GetSet, // tp_getset
  nullptr, // tp_base
  nullptr, // tp_dict
  nullptr, // tp_descr_get
  nullptr, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  nullptr, // tp_init
  nullptr, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  nullptr, // tp_is_gc
  nullptr, // tp_bases
  nullptr, // tp_mro
  nullptr, // tp_cache
  nullptr, // tp_subclasses
  nullptr, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkReebGraphSimplificationFilter_StaticNew()
{
  return vtkReebGraphSimplificationFilter::New();
}

PyObject *PyvtkReebGraphSimplificationFilter_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkReebGraphSimplificationFilter_Type, PyvtkReebGraphSimplificationFilter_Methods,
    "vtkReebGraphSimplificationFilter",
 &PyvtkReebGraphSimplificationFilter_StaticNew);

  PyTypeObject *pytype = &PyvtkReebGraphSimplificationFilter_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkDirectedGraphAlgorithm_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

void PyVTKAddFile_vtkReebGraphSimplificationFilter(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkReebGraphSimplificationFilter_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkReebGraphSimplificationFilter", o) != 0)
  {
    Py_DECREF(o);
  }

}

